import { Request, Response, Router } from "express";

export default class ApiRouter {
  private static _instance: Router;

  private constructor() {
    return this;
  }

  private static initRoutes() {
    this._instance.get("/ping", (req: Request, res: Response) => {
      res.json("pong").status(200);
    });
  }

  private static buildPetition(req: Request, res: Response) {
    return {
      request: { ...req, payload: req.body },
      response: { ...res, status: "OK" }
    };
  }

  public static get instance(): Router {
    if (!this._instance) {
      this._instance = Router();
      this.initRoutes();
    }
    return this._instance;
  }
}
