import { Request, Response, Router } from "express";

export default class WebRouter {
  private static _instance: Router;

  private constructor() {
    return this;
  }

  private static initRoutes() {
    this._instance.get("/status", (req: Request, res: Response) => {
      res.send("OK").status(200);
    });
  }

  public static get instance() {
    if (!this._instance) {
      this._instance = Router();
      this.initRoutes();
    }
    return this._instance;
  }
}
